/*!
 *  @file Air.h
 *  @brief ゲーム中の空間情報のプロトタイプ
 *  @date 2014/02/20
 *  @author Deskull
 *  2014 Sikabane Works.
 */

#pragma once

#include "stdafx.h"
#include "GameElement.h"
#include "HaveSymbol.h"
#include "HaveHp.h"
#include "Color.h"
#include "Dice.h"

namespace Deeangband
{
	class Color;

	/*!
	 * @class Air
	 * @brief 空間情報のクラス
	 */
	class Air : public GameElement, public HaveSymbol, public HaveHp
	{
	private:

		friend class boost::serialization::access;
		Dice effectDice; //!< 空間所在中のエフェクト値

		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & boost::serialization::make_nvp("Name", name);
				archive & boost::serialization::make_nvp("TileID", tileID);
				archive & boost::serialization::make_nvp("Symbol", symbol);
				archive & boost::serialization::make_nvp("SymbolColor", symbolColor);
				archive & boost::serialization::make_nvp("BackColor", backColor);
				if(version >= 11) archive & boost::serialization::make_nvp("EffectDice", effectDice);
			}
		}

	public:

		/*! 
		 * @brief Airクラスコンストラクタ
		 */
		Air::Air(void);

		/*! 
		 * @brief ダミーデータによる初期化
		 * @return なし
		 */
		void Air::WipeData(void);

		/*! 
		 * @brief Airクラスデストラクタ
		 */
		Air::~Air(void);

	};

}

BOOST_CLASS_VERSION(Deeangband::Air, 11);
